Require Export algoSat2.
Require Export varList.
Require Export makeTriplet.
Require Export memoryInit.

Definition DoStal: (e:Expr){b:bool | b=true ->(Tautology e)}.
Intros e.
Apply LetP with h := (makeTriplets (norm e)).
Intros t; Case t.
Intros LL s n EqLLsn.
Case (listDec ? tripletDec LL (nil ?)); Intros Eq1; Auto.
Generalize EqLLsn; Case s.
Intros r; Case (rNatDec r zero).
Intros H' H'0; Exists true.
Intros H'1; Case (TautoRTauto e).
Intros H'2 H'3; Apply H'3; Auto.
Red; Auto.
Intros f H'4.
Rewrite (rZEvalEvalRZMakeTriplets f (norm e) LL n (rZPlus r)); Auto.
Rewrite H'; Auto.
Rewrite Eq1; Auto.
Intros H' H'0; Exists false; Intros; Discriminate.
Intros r H'; Exists false; Intros; Discriminate.
Apply LetP with h := (rnext (maxVarTriplets LL)).
Intros maxN HmaxN.
Apply LetP with h := (varList LL maxN HmaxN).
Intros varList Hvar.
Cut (rVlt s maxN); [Intros Hs | Idtac].
Cut (v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL); [Intros Hh | Idtac].
Case (addAndDoTripletsF
        LL maxN HmaxN varList Hh (initMem maxN) s rZFalse Hs
        (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M' b' d'; Case b'; Simpl; Intros H'; Elim H'; Intros H'0 H'1; Elim H'1;
 Intros H'2 H'3; Elim H'3; Intros H'4 H'5; Clear H'3 H'1 H'.
Exists true; Auto.
Generalize (stalmarckCorrect e (cons ((rZPlus zero), (rZMinus zero)) (nil ?))).
Rewrite <- EqLLsn; Auto.
Intros H' H'1; Apply H'; Auto.
Apply stalmarckTrans with S2 := (cons ((rZPlus zero), (rZMinus zero)) (nil ?));
 Auto.
Apply dilemmaPRef; Auto.
Apply doTripletsComp with 1 := H'0; Auto.
Apply eqStateAddEq; Auto.
Apply eqStateSym; Apply initMemMemF.
Red; Exists (rZPlus zero); Auto.
Case (Sat1
        LL maxN HmaxN varList Hh M' (initCopyMem maxN M') (initCopyMem maxN M')).
Apply initCopyMemEq; Auto.
Apply initCopyMemEq; Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 b''; Case b''; Simpl; Intros H'; Elim H'; Clear H';
 Intros H'1 H'3; Elim H'3; Intros H'3 H'4.
Exists true; Auto.
Generalize (stalmarckCorrect e (cons ((rZPlus zero), (rZMinus zero)) (nil ?))).
Rewrite <- EqLLsn; Auto.
Intros H' H'1; Apply H'; Auto.
Apply stalmarckTrans with S2 := (memF maxN M'); Auto.
Apply dilemmaPRef; Auto.
Apply doTripletsComp with 1 := H'0; Auto.
Apply eqStateAddEq; Auto.
Apply eqStateSym; Apply initMemMemF.
Red; Exists (rZPlus zero); Auto.
Case (Sat2 LL maxN HmaxN varList Hh M'1 M'2 M'3 (initCopyMem maxN M'1)); Auto.
Apply initCopyMemEq; Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 M''4 b'''; Case b'''; Simpl; Intros H'; Elim H';
 Intros H'8 H'9; Elim H'9; Intros H'10 H'11; Elim H'11; Intros H'12 H'13;
 Clear H'11 H'9 H'.
Exists true; Auto.
Generalize (stalmarckCorrect e (cons ((rZPlus zero), (rZMinus zero)) (nil ?))).
Rewrite <- EqLLsn; Auto.
Intros H' H'1; Apply H'; Auto.
Apply stalmarckTrans with S2 := (memF maxN M'); Auto.
Apply dilemmaPRef; Auto.
Apply doTripletsComp with 1 := H'0; Auto.
Apply eqStateAddEq; Auto.
Apply eqStateSym; Apply initMemMemF.
Apply stalmarckrTrans with S2 := (memF maxN M'1); Auto.
Red; Exists (rZPlus zero); Auto.
Exists false; Auto.
Intros; Discriminate.
Rewrite Hvar; Auto.
Intros v Hv.
Apply varListIn; Auto.
Apply inTripletmaxN with LL := LL; Auto.
Generalize (makeTripletsIn (norm e)).
Rewrite <- EqLLsn; Auto.
Defined.

