Section Prod.
Variable A:Set.
Variable ltA:A -> A ->Prop.
Hypothesis ltAWf:(well_founded ? ltA).

Mutual Inductive lexProd: A * A -> A * A ->Prop :=
     lexProd1: (a1, b1, b2:A) (ltA b1 b2) ->(lexProd (a1, b1) (a1, b2))
    | lexProd2: (a1, b1, a2, b2:A) (ltA a1 a2) ->(lexProd (a1, b1) (a2, b2)) .

Theorem well_founded_lex: (well_founded ? lexProd).
Red.
Induction a.
Intros x; Pattern x; Apply (well_founded_ind A ltA ltAWf); Auto.
Intros x0 H'.
Intros y; Pattern y; Apply (well_founded_ind A ltA ltAWf); Auto.
Intros y0 H'0; Apply Acc_intro.
Intros p H'1; Inversion H'1.
Apply H'0; Auto.
Apply H'; Auto.
Qed.
End Prod.
